﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Runtime.Remoting.Channels;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using System.Xml.Serialization;
using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;

namespace WpfApplication9
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Person obj = new Person();
        
        public MainWindow()
        {
            InitializeComponent();
            PropertyDemo.SelectedObject = obj;

        }

        public void SerializeToXML(Person obj)
        {
            
            XmlSerializer serializer = new XmlSerializer(typeof(Person));
            TextWriter textwriter = new StreamWriter(@"D:\PersonInfo.xml");
            serializer.Serialize(textwriter, obj);
            textwriter.Close();
            
        }

        public void DesrializeFromXML(Person obj)
        {
            XmlSerializer deSerializer = new XmlSerializer(typeof(Person));
            StreamReader myfileStream = new StreamReader(@"D:\PersonInfo.xml");
            Person objPerson = (Person)deSerializer.Deserialize(myfileStream);
            myfileStream.Close();
            



        }

        private void button_Click(object sender, RoutedEventArgs e)
        {
           
            SerializeToXML(obj);
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
          
            DesrializeFromXML(obj);

        }       
               
    }


    [Serializable]
    [TypeConverter(typeof(ExpandableObjects))]
    public class Person:INotifyPropertyChanged

    {
        private object _Name = "Hello";   



        [CategoryAttribute("Identity")]
        [DisplayNameAttribute("Name")]
        [DescriptionAttribute("Name of the actual person.")]
        public object  Name
        {
            get { return _Name; }
            set { 
                _Name = value;
                NotifyPropertyChanged("Name"); 
            } 
           
        }
      public event PropertyChangedEventHandler PropertyChanged;

      private void NotifyPropertyChanged(string name)
    {
       if (PropertyChanged != null)
        PropertyChanged(this, new PropertyChangedEventArgs(name));
      }

        //[CategoryAttribute("Identity")]
        //[DisplayNameAttribute("ID")]
        //[DescriptionAttribute("ID of the actual person.")]
        //public object ID
        //{
        //    get { return _ID; }
        //    set { _ID = value; }
        //}

        //[CategoryAttribute("Identity")]
        //[DisplayNameAttribute("Mode")]
        //[DescriptionAttribute("Birth date of the actual person.")]
        //public object Mode
        //{
        //    get { return _Mode; }
        //    set { _Mode = value; }
        //}


        //[CategoryAttribute("Contact Details")]
        //[DisplayNameAttribute("Email ID")]
        //[DescriptionAttribute("Email address of the actual person.")]
        //public object Email
        //{
        //    get { return _Email; }
        //    set { _Email = value; }
        //}

    }
  
}
